## mitsuba-b85118cd30d2.zip

=== CMakeLists.txt ===
# Experimental CMake file for Mitusba
# Tested only on Windows and Linux (Ubuntu 10.10)
cmake_minimum_required(VERSION 2.8.3 FATAL_ERROR)

# Internal variable to know whether this is the first time CMake runs
if (NOT DEFINED MTS_CMAKE_INIT)
  set(MTS_CMAKE_INIT ON CACHE INTERNAL "Is this the initial CMake run?")
else()
  set(MTS_CMAKE_INIT OFF CACHE INTERNAL "Is this the initial CMake run?")
endif()

# Allow to override the default project name "mitsuba"
if (NOT DEFINED MTS_PROJECT_NAME)
  set(MTS_PROJECT_NAME "mitsuba")
endif()
project(${MTS_PROJECT_NAME})

# Tell cmake where to find the additional modules
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/data/cmake")
# Make sure the cmake-provided modules use the versions they expect
if(NOT CMAKE_VERSION VERSION_LESS "2.8.4")
  cmake_policy(SET CMP0017 NEW)
endif()

# Enable folders for projects in Visual Studio
if (CMAKE_GENERATOR MATCHES "Visual Studio")
  set_property(GLOBAL PROPERTY USE_FOLDERS ON)
endif()

# Remove Debug from CMAKE_CONFIGURATION_TYPES as the dependencies do not contain the necessary debug libraries
if(MSVC AND CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_CONFIGURATION_TYPES Release MinSizeRel RelWithDebInfo)
  set(CMAKE_CONFIGURATION_TYPES "${CMAKE_CONFIGURATION_TYPES}" CACHE STRING
    "Remove Debug from available configuration types"
     FORCE)
endif()


# make config 'RelWithDebInfo' debuggable by disabling optimizations
if(MSVC)
  # /MD link against release libs, /Od disable optimizations, /Ob0
  if(CMAKE_C_FLAGS_RELWITHDEBINFO MATCHES "/O2")
    string(REGEX REPLACE "/O2" "/Od" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
  endif()
  if(CMAKE_CXX_FLAGS_RELWITHDEBINFO MATCHES "/O2")
    string(REGEX REPLACE "/O2" "/Od" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
  endif()
  if(CMAKE_C_FLAGS_RELWITHDEBINFO MATCHES "/Ob1")
    string(REGEX REPLACE "/Ob1" "/Ob0" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
  endif()
  if(CMAKE_CXX_FLAGS_RELWITHDEBINFO MATCHES "/Ob1")
    string(REGEX REPLACE "/Ob1" "/Ob0" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
  endif()
  set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /RTC1")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /RTC1")
  list(REMOVE_DUPLICATES CMAKE_C_FLAGS_RELWITHDEBINFO)
  list(REMOVE_DUPLICATES CMAKE_CXX_FLAGS_RELWITHDEBINFO)
endif()

# Set CMAKE_BUILD_TYPE to Release by default
if (MTS_CMAKE_INIT AND DEFINED CMAKE_BUILD_TYPE AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Choose the type of build, options are: Debug, Release, RelWithDebInfo, MinSizeRel." FORCE)
endif()

# Load the required modules
include (MitsubaUtil)
include (MtsGetVersionInfo)
include (CheckCXXSourceCompiles)
include (CMakeDependentOption)

# Read the version information
MTS_GET_VERSION_INFO()
if (MTS_HAS_VALID_REV)
  message(STATUS "mitsuba ${MTS_VERSION}-hg${MTS_REV_ID} (${MTS_DATE})")
else()
  message(STATUS "mitsuba ${MTS_VERSION} (${MTS_DATE})")
endif()

# Setup the build options
include (MitsubaBuildOptions)

# Find the external libraries and setup the paths
include (MitsubaExternal)

# Main mitsuba include directory
include_directories("include")

# ===== Prerequisite resources =====

# Process the XML schemas
add_subdirectory(data/schema)
# Add the IOR database
add_subdirectory(data/ior)
# Microfacet precomputed data
add_subdirectory(data/microfacet)


# ===== Build the support libraries ====

# Core support library
add_subdirectory(src/libcore)
# Rendering-related APIs
add_subdirectory(src/librender)
# Hardware acceleration
add_subdirectory(src/libhw)
# Bidirectional support library
add_subdirectory(src/libbidir)
# Python binding library
if (BUILD_PYTHON)
  add_subdirectory(src/libpython)
elseif(NOT PYTHON_FOUND)
  message(STATUS "Python was not found. The bindings will not be built.")
endif()


# Additional files to add to main executables
if(APPLE)
  set(MTS_DARWIN_STUB "${CMAKE_CURRENT_SOURCE_DIR}/src/mitsuba/darwin_stub.mm")
  set(MTS_WINDOWS_STUB "")
elseif(WIN32)
  set(MTS_DARWIN_STUB "")
  set(MTS_WINDOWS_STUB "${CMAKE_CURRENT_SOURCE_DIR}/data/windows/wmain_stub.cpp")
else()
  set(MTS_DARWIN_STUB "")
  set(MTS_WINDOWS_STUB "")
endif()


# ===== Build the applications =====

# Build the command-line binaries
add_subdirectory(src/mitsuba)

# Build the COLLADA converter
if (COLLADA_FOUND)
  add_subdirectory(src/converter)
else()
  message(STATUS "Collada DOM was not found. The importer will not be built.")
endif()

# Build the Qt-based GUI binaries
if (BUILD_GUI)
  add_subdirectory(src/mtsgui)
elseif(NOT QT4_FOUND)
  message(STATUS "Qt4 was not found. The mitsuba gui will not be built.")
endif()


# ===== Build the plugins =====

# Utilities
add_subdirectory(src/utils)
# Surface scattering models
add_subdirectory(src/bsdfs)
# Phase functions
add_subdirectory(src/phase)
# Intersection shapes
add_subdirectory(src/shapes)
# Sample generators
add_subdirectory(src/samplers)
# Reconstruction filters
add_subdirectory(src/rfilters)
# Film implementations
add_subdirectory(src/films)
# Sensors
add_subdirectory(src/sensors)
# Emitters
add_subdirectory(src/emitters)
# Participating media
add_subdirectory(src/medium)
# Volumetric data sources
add_subdirectory(src/volume)
# Sub-surface integrators
add_subdirectory(src/subsurface)
# Texture types
add_subdirectory(src/textures)
# Integrators
add_subdirectory(src/integrators)
# Testcases
add_subdirectory(src/tests)


# ===== Packaging =====

# Use a subdirectory to enforce that packaging runs after all other targets
add_subdirectory(data/cmake/packaging)

=== SConstruct ===
import SCons
import sys
import glob
import os

resources = []
plugins = []
stubs = []
winstubs = []

Export('SCons', 'sys', 'os', 'glob', 'resources',
	'plugins', 'stubs', 'winstubs')

# Configure the build framework
env = SConscript('build/SConscript.configure')

Export('env')

if sys.platform == 'win32':
	# Set an application icon on Windows
	resources += [ env.RES('data/windows/mitsuba_res.rc') ]
	# Convert the command line args from UTF-8 to UTF-16
	winstubs += [ env.SharedObject('#data/windows/wmain_stub.cpp') ]
	Export('winstubs')

def build(scriptFile, exports = [], duplicate = 0):
	dirname = '/'.join(os.path.dirname(scriptFile).split('/')[1:])
	return SConscript(scriptFile, exports,
		variant_dir=os.path.join(env['BUILDDIR'], dirname), duplicate=duplicate)

# ===== Build the support libraries ====

# Core support library
build('src/libcore/SConscript')
# Rendering-related APIs
build('src/librender/SConscript')
# Hardware acceleration
build('src/libhw/SConscript')
# Bidirectional support library
build('src/libbidir/SConscript')
# Python binding library
build('src/libpython/SConscript')

# ===== Build the applications =====
env = env.Clone()

# Build the command-line binaries
mainEnv = build('src/mitsuba/SConscript')

# Build the COLLADA converter
converter_objects = build('src/converter/SConscript', ['mainEnv'])

# Build the Qt-based GUI binaries
build('src/mtsgui/SConscript', ['mainEnv', 'converter_objects'], duplicate=True)

env['SHLIBPREFIX']=''

# ===== Build the plugins =====

Export('env')

# Utilities
build('src/utils/SConscript')
# Surface scattering models
build('src/bsdfs/SConscript')
# Phase functions
build('src/phase/SConscript')
# Intersection shapes
build('src/shapes/SConscript')
# Sample generators
build('src/samplers/SConscript')
# Reconstruction filters
build('src/rfilters/SConscript')
# Film implementations
build('src/films/SConscript')
# Sensors
build('src/sensors/SConscript')
# Emitters
build('src/emitters/SConscript')
# Participating media
build('src/medium/SConscript')
# Volumetric data sources
build('src/volume/SConscript')
# Sub-surface integrators
build('src/subsurface/SConscript')
# Texture types
build('src/textures/SConscript')
# Integrators
build('src/integrators/SConscript')
# Testcases
build('src/tests/SConscript')

# ===== Move everything to its proper place =====
SConscript('build/SConscript.install')

=== doc/Makefile ===
all: 
	./gendoc.py
	
clean:
	$(RM) main.pdf
	$(RM) plugins_generated.tex
	$(RM) *.aux main.bbl main.blg main.log main.out main.toc

=== data/ior/CMakeLists.txt ===
# IOR Database
if (NOT MTS_VERSION)
  message(FATAL_ERROR "Use the top level configuration file")
endif()

if (WIN32 OR MTS_SIMPLE_PATHS)
  set(IOR_DESTINATION "data/ior")
elseif (APPLE)
  set(IOR_DESTINATION "${MTS_BUNDLE_NAME}/data/ior")
else()
  set(IOR_DESTINATION "share/mitsuba/data/ior")
endif()

set (IOR_DIR "${PROJECT_BINARY_DIR}/binaries/${CMAKE_CFG_INTDIR}/${IOR_DESTINATION}")
  
# Actual installation
install(DIRECTORY "."
  DESTINATION "${IOR_DESTINATION}"
  FILE_PERMISSIONS "OWNER_READ" "GROUP_READ" "WORLD_READ"
  COMPONENT Runtime
  FILES_MATCHING PATTERN "*.spd"
)

# Custom target wich creates a phony file, just to flag that the database
# has already been copied
add_custom_command(OUTPUT "${IOR_DIR}/.iordatabase.flag"
  COMMAND "${CMAKE_COMMAND}" -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}" "${IOR_DIR}"
  COMMAND "${CMAKE_COMMAND}" -E remove -f "${IOR_DIR}/CMakeLists.txt"
  COMMAND "${CMAKE_COMMAND}" -E touch "${IOR_DIR}/.iordatabase.flag"
  COMMENT "Copying IOR database directory"
)
add_custom_target (ior_database DEPENDS "${IOR_DIR}/.iordatabase.flag")
set_target_properties (ior_database PROPERTIES FOLDER "data")

=== data/microfacet/CMakeLists.txt ===
# Microfacet precomputed data
if (NOT MTS_VERSION)
  message(FATAL_ERROR "Use the top level configuration file")
endif()

if (WIN32 OR MTS_SIMPLE_PATHS)
  set(MICROFACET_DESTINATION "data/microfacet")
elseif (APPLE)
  set(MICROFACET_DESTINATION "${MTS_BUNDLE_NAME}/data/microfacet")
else()
  set(MICROFACET_DESTINATION "share/mitsuba/data/microfacet")
endif()
  
# Copy the microfacet data into the output directory, mainly for easier debugging
set (MICROFACET_DIR "${PROJECT_BINARY_DIR}/binaries/${CMAKE_CFG_INTDIR}/${MICROFACET_DESTINATION}")
add_custom_command (
  OUTPUT "${MICROFACET_DIR}/beckmann.dat"
         "${MICROFACET_DIR}/ggx.dat"
         "${MICROFACET_DIR}/phong.dat"
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
          "${CMAKE_CURRENT_SOURCE_DIR}/beckmann.dat" "${MICROFACET_DIR}/beckmann.dat"
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
          "${CMAKE_CURRENT_SOURCE_DIR}/ggx.dat" "${MICROFACET_DIR}/ggx.dat"
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
          "${CMAKE_CURRENT_SOURCE_DIR}/phong.dat" "${MICROFACET_DIR}/phong.dat"
  DEPENDS "beckmann.dat" "ggx.dat" "phong.dat"
  COMMENT "Copying microfacet precomputed data"
)
add_custom_target (microfacet_data
  DEPENDS "${MICROFACET_DIR}/beckmann.dat"
          "${MICROFACET_DIR}/ggx.dat"
          "${MICROFACET_DIR}/phong.dat"
)
set_target_properties (microfacet_data PROPERTIES FOLDER "data")

# Actual installation
install(FILES "beckmann.dat" "ggx.dat" "phong.dat"
  DESTINATION ${MICROFACET_DESTINATION}
  PERMISSIONS "OWNER_READ" "GROUP_READ" "WORLD_READ"
  COMPONENT Runtime
)

=== data/plugin-starter-kit/SConstruct ===
import os

env = Environment(ENV = os.environ, tools=['default'])
env['SHLIBPREFIX'] = ''
env.SharedLibrary('plugins/myutil', ['myutil.cpp'])

=== data/schema/CMakeLists.txt ===
# Scene XML Schema and XSL transformer
if (NOT MTS_VERSION)
  message(FATAL_ERROR "Use the top level configuration file")
endif()

if (WIN32 OR MTS_SIMPLE_PATHS)
  set(SCHEMA_DESTINATION "data/schema")
elseif (APPLE)
  set(SCHEMA_DESTINATION "${MTS_BUNDLE_NAME}/data/schema")
else()
  set(SCHEMA_DESTINATION "share/mitsuba/data/schema")
endif()
  
# Copy the XML components into the output directory, mainly for easier debugging
set (SCHEMA_DIR "${PROJECT_BINARY_DIR}/binaries/${CMAKE_CFG_INTDIR}/${SCHEMA_DESTINATION}")
add_custom_command (
  OUTPUT "${SCHEMA_DIR}/scene.xsd"
         "${SCHEMA_DIR}/upgrade_0.3.0.xsl"
         "${SCHEMA_DIR}/upgrade_0.4.0.xsl"
         "${SCHEMA_DIR}/upgrade_0.5.0.xsl"
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
          "${CMAKE_CURRENT_SOURCE_DIR}/scene.xsd" "${SCHEMA_DIR}/scene.xsd"
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
          "${CMAKE_CURRENT_SOURCE_DIR}/upgrade_0.3.0.xsl" "${SCHEMA_DIR}/upgrade_0.3.0.xsl"
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
          "${CMAKE_CURRENT_SOURCE_DIR}/upgrade_0.4.0.xsl" "${SCHEMA_DIR}/upgrade_0.4.0.xsl"
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
          "${CMAKE_CURRENT_SOURCE_DIR}/upgrade_0.5.0.xsl" "${SCHEMA_DIR}/upgrade_0.5.0.xsl"
  MAIN_DEPENDENCY "scene.xsd"
  DEPENDS "scene.xsd" "upgrade_0.3.0.xsl" "upgrade_0.4.0.xsl" "upgrade_0.5.0.xsl"
  COMMENT "Copying XML data: scene schema and upgrade XSL files"
)
add_custom_target (scene_schema
  DEPENDS "${SCHEMA_DIR}/scene.xsd"
          "${SCHEMA_DIR}/upgrade_0.3.0.xsl" "${SCHEMA_DIR}/upgrade_0.4.0.xsl" "${SCHEMA_DIR}/upgrade_0.5.0.xsl"
)
set_target_properties (scene_schema PROPERTIES FOLDER "data")

# Actual installation
install(FILES "scene.xsd" "upgrade_0.3.0.xsl" "upgrade_0.4.0.xsl" "upgrade_0.5.0.xsl"
  DESTINATION ${SCHEMA_DESTINATION}
  PERMISSIONS "OWNER_READ" "GROUP_READ" "WORLD_READ"
  COMPONENT Runtime
)

=== src/bsdfs/CMakeLists.txt ===
# Surface scattering models
if (NOT MTS_VERSION)
  message(FATAL_ERROR "Use the top level configuration file")
endif()

macro(add_bsdf)
  add_mts_plugin(${ARGN} MTS_HW TYPE bsdf)
endmacro()

# Basic library of smooth and rough materials
add_bsdf(diffuse         diffuse.cpp)
add_bsdf(dielectric      dielectric.cpp ior.h)
add_bsdf(conductor       conductor.cpp)
add_bsdf(plastic         plastic.cpp ior.h)
add_bsdf(roughdiffuse    roughdiffuse.cpp)
add_bsdf(roughdielectric roughdielectric.cpp microfacet.h ior.h)
add_bsdf(roughconductor  roughconductor.cpp microfacet.h)
add_bsdf(roughplastic    roughplastic.cpp microfacet.h ior.h)

# Materials that act as modifiers
add_bsdf(bumpmap      bumpmap.cpp)
add_bsdf(normalmap    normalmap.cpp)
add_bsdf(twosided     twosided.cpp)
add_bsdf(mask         mask.cpp)
add_bsdf(mixturebsdf  mixturebsdf.cpp)
add_bsdf(blendbsdf    blendbsdf.cpp)
add_bsdf(coating      coating.cpp ior.h)
add_bsdf(roughcoating roughcoating.cpp ior.h)

# Other materials
add_bsdf(ward       ward.cpp)
add_bsdf(phong      phong.cpp)
add_bsdf(difftrans  difftrans.cpp)
add_bsdf(hk         hk.cpp)
add_bsdf(null       null.cpp)
add_bsdf(thindielectric thindielectric.cpp)


if (BOOST_SPIRIT_WORKS)
  add_bsdf(irawan   irawan.h irawan.cpp)
endif ()

=== src/converter/CMakeLists.txt ===
# COLLADA/OBJ importer (mtsimport)
if (NOT MTS_VERSION)
  message(FATAL_ERROR "Use the top level configuration file")
endif()

include_directories(${COLLADA_INCLUDE_DIRS} ${XERCES_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR})

set(SRCS
  collada.cpp
  converter.h
  converter.cpp
  obj.cpp
)

# COLLADA-DOM 2.4 introduces namespaces, which are not source-compatible
if (COLLADA_NAMESPACE)
  add_definitions(${COLLADA_DEFINITIONS} -DCOLLADA_DOM_2_4)
endif()

# Create a static library which is also used by mtsgui. Adding the dependent
# libraries will allow transitive linking.
add_library(mtsconverter_lib STATIC ${SRCS})
target_link_libraries(mtsconverter_lib
	${COLLADA_LIBRARIES} ${XERCES_LIBRARIES} ${OPENGL_glu_LIBRARY})

add_mts_exe(mtsimport mtsimport.cpp ${SRCS}
  ${MTS_DARWIN_STUB} ${MTS_WINDOWS_STUB} MTS_HW LINK_LIBRARIES mtsconverter_lib
  RES_DESCRIPTION "Mitsuba COLLADA 1.4 & Wavefront OBJ importer")

=== src/emitters/CMakeLists.txt ===
# Light sources
if (NOT MTS_VERSION)
  message(FATAL_ERROR "Use the top level configuration file")
endif()

macro(add_emitter)
  add_mts_plugin(${ARGN} TYPE emitter)
endmacro()

add_emitter(area        area.cpp)
add_emitter(collimated  collimated.cpp)
add_emitter(directional directional.cpp)
add_emitter(point       point.cpp)
add_emitter(constant    constant.cpp)
add_emitter(envmap      envmap.cpp MTS_HW)
add_emitter(sky         sky.cpp sunsky/skymodel.cpp sunsky/skymodel.h sunsky/skymodeldata.h sunsky/sunmodel.h)
add_emitter(sun         sun.cpp sunsky/sunmodel.h)
add_emitter(sunsky      sunsky.cpp sunsky/sunmodel.h)
add_emitter(spot        spot.cpp   MTS_HW)

=== src/films/CMakeLists.txt ===
# Film implementations
if (NOT MTS_VERSION)
  message(FATAL_ERROR "Use the top level configuration file")
endif()

macro(add_film)
  add_mts_plugin(${ARGN} TYPE film)
endmacro()

add_film(mfilm   mfilm.cpp cnpy.h cnpy.cpp)
add_film(ldrfilm ldrfilm.cpp annotations.h banner.h MTS_HW)
add_film(hdrfilm hdrfilm.cpp annotations.h banner.h MTS_HW)

if (OPENEXR_FOUND)
  include_directories(${ILMBASE_INCLUDE_DIRS} ${OPENEXR_INCLUDE_DIRS})
  add_film(tiledhdrfilm tiledhdrfilm.cpp)
endif()

=== src/integrators/CMakeLists.txt ===
# Integrators
if (NOT MTS_VERSION)
  message(FATAL_ERROR "Use the top level configuration file")
endif()

macro(add_integrator)
  add_mts_plugin(${ARGN} TYPE integrator)
endmacro()

macro(add_bidir)
  add_integrator(${ARGN} MTS_BIDIR)
endmacro()

add_integrator(ao       direct/ao.cpp)
add_integrator(direct   direct/direct.cpp)
add_integrator(path     path/path.cpp)
add_integrator(volpath  path/volpath.cpp)
add_integrator(volpath_simple path/volpath_simple.cpp)
add_integrator(ptracer  ptracer/ptracer.cpp
                        ptracer/ptracer_proc.h ptracer/ptracer_proc.cpp)

# Photon mapping-based techniques
add_integrator(photonmapper photonmapper/photonmapper.cpp photonmapper/bre.cpp)
add_integrator(ppm          photonmapper/ppm.cpp)
add_integrator(sppm         photonmapper/sppm.cpp)

# Miscellaneous
add_integrator(vpl          vpl/vpl.cpp MTS_HW)
add_integrator(adaptive     misc/adaptive.cpp)
add_integrator(irrcache     misc/irrcache.cpp
                            misc/irrcache_proc.h misc/irrcache_proc.cpp)
add_integrator(multichannel misc/multichannel.cpp)
add_integrator(field        misc/field.cpp)

# Bidirectional techniques
add_bidir(bdpt          bdpt/bdpt.h      bdpt/bdpt.cpp
                        bdpt/bdpt_proc.h bdpt/bdpt_proc.cpp
                        bdpt/bdpt_wr.h   bdpt/bdpt_wr.cpp)

add_bidir(pssmlt        pssmlt/pssmlt.h         pssmlt/pssmlt.cpp
                        pssmlt/pssmlt_proc.h    pssmlt/pssmlt_proc.cpp
                        pssmlt/pssmlt_sampler.h pssmlt/pssmlt_sampler.cpp)

add_bidir(mlt           mlt/mlt.h      mlt/mlt.cpp
                        mlt/mlt_proc.h mlt/mlt_proc.cpp)

add_bidir(erpt          erpt/erpt.h      erpt/erpt.cpp
                        erpt/erpt_proc.h erpt/erpt_proc.cpp)

=== data/linux/debian/changelog ===
mitsuba (0.5.0-1) unstable; urgency=low
  * Mitsuba can now perform renderings of images with multiple channels
    (e.g. a path traced rendering plus surface normals and depth). All
    channels are rendered in one pass and written to a multi-channel EXR file.
  * Anton Kaplanyan contributed mtsgui GUI usability tweaks and several
    MLT-related robustness improvements
  * Greatly improved Python integration, nice interaction with PyQt and NumPy,
    Python 3.3. support on all platforms
  * The 'mfilm' plugin now supports writing binary NumPy files (Joe Kider)
  * Switch tabs in the gui using Alt+Left/Right keys
  * Ask whether to stop long-running rendering processes when dragging the
    mouse in the GUI
  * Windows 8 compatibility
  * CMake build system working again (Edgar Velázquez-Armendáriz)
  * Statistics are now automatically reset between renderings
  * mtssrv robustness improvements on OSX
  * The 'thindielectric' plugin still computed incorrect results in some
    situations, which is now fixed
  * Added a new 'default' XML tag
 -- Wenzel Jakob <wenzel@cs.cornell.edu>  Tue, 25 Feb 2014 00:00:00 -0400

mitsuba (0.4.5-1) unstable; urgency=low
  * New height field intersection shape
  * kd-tree precision improvements when rendering in double precision
  * Feature to create a bitmap texture from a single color channel of an image
  * Python API: More complete coverage of the Mitsuba core API
  * Feature to quickly convert between Mitsuba images and Python byte arrays.
  * Frequency-space convolution of large-scale images using FFTW3
  * Bloom filter in support in 'mtsutil tonemap'
  * OSX 10.9 font fixes, initial improvements for machines with a retina display
  * New perspective camera with model radial distortion
  * Python 3.3 support on Windows
  * Collecting rendering statistics turned out to cause severe memory
    contention on previous releases. This has now been fixed, leading to
    significant speedups on machines with many cores (>4).
  * Worker threads now request CPU affinity on platforms where this is supported
  * Many smaller robustness fixes and bugfixes in various parts of the
    renderer -- see the changelog for details
 -- Wenzel Jakob <wenzel@cs.cornell.edu>  Mon, 04 Nov 2013 00:00:00 -0400

mitsuba (0.4.4-1) unstable; urgency=low
  * Improved Python support for rendering animations and motion blur
  * Photon mapper logic rewrite to account for certain missing specular paths
  * Robustness improvements for specular+diffuse materials such as 'plastic'
  * Fixed a remaining issue in the instancing frame computation code
  * The thindielectric plugin formerly computed incorrect transmittance values
  * The cube shape is now centered at the origin by default
  * The TLS cleanup logic has been fixed to avoid a potential crash in mtssrv
  * Other minor improvements, which are listed in the repository log
 -- Wenzel Jakob <wenzel@cs.cornell.edu>  Thu, 28 Feb 2013 00:00:00 -0400

mitsuba (0.4.3-1) unstable; urgency=low
  * Motion blur: Support for arbitrary linear camera, object, and sensor motion
    to produce motion blur in renderings.
  * Render-time annotations: added the ability to tag image files with additional
    information by means of metadata or text labels.
  * Hide directly visible emitters: convenient feature for removing an environment
    light source so that an image can be composited onto documents having a
    different color.
  * Improved instancing: more robust instancing code with support for
    non-rigid transformations.
  * Threading on Windows: fixed various threading-related issues on Windows that
    previously caused crashes and deadlocks.
  * Caching: Caching mechanism to further accelerate the loading of
    .serialized files.
  * File dialogs: Native File Open/Save dialogs are now used on Windows.
  * Python: Improved python bindings; easier usage on MacOS X.
  * Blender interaction: Fixed a issue where GUI tabs containing scenes created
    in Blender could not be cloned.
  * Non-uniform scales: All triangle mesh-based shapes now permit
    non-uniform scales.
  * NaNs and friends: Increased resilience against various numerical corner cases.
  * Index-matched participating media: Fixed an unfortunate regression in volpath
    regarding index-matched media that was accidentally introduced in 0.4.2.
  * roughdiffuse: Fixed texturing support in the roughdiffuse plugin.
  * Photon mapping: Fixed some inaccuracies involving participating media when
    rendered by the photon mapper and the Beam Radiance Estimate.
  * Conductors: Switched Fresnel reflectance computations for conductors to the
    exact expressions predicted by geometric optics (an approximation was
    previously used).
  * New cube shape: Added a cube shape plugin for convenience. This does
    exactly what one would expect.
  * The rest: As usual, a large number of smaller bugfixes and improvements
    were below the threshold and are thus not listed individually. The
    repository log has more details.
 -- Wenzel Jakob <wenzel@cs.cornell.edu>  Tue, 29 Jan 2013 00:00:00 -0400

mitsuba (0.4.2-1) unstable; urgency=low
  * Volumetric path tracers: improved sampling when dealing with index-matched medium transitions. This is essentially a re-implementation of an optimization that Mitsuba 0.3.1 already had, but which got lost in the bidirectional rewrite.
  * Batch tonemapper: due to an unfortunate bug, the batch tonemapper in the last release produced invalid results for images containing an alpha channel. This is now fixed.
  * Shapes: corrected some differential geometry issues in the "cylinder" and "rectangle" shapes.
  * MLT: fixed 2-stage MLT, which was producing incorrect results.
  * MEPT: fixed the handling of directional light sources.
  * Robustness: got rid of various corner-cases that could produce NaNs.


=== data/linux/arch/collada-dom/PKGBUILD ===
# Contributer: N30N <archlinux@alunamation.com>
# Contributer: Wenzel Jakob <wenzel@mitsuba-renderer.org>

pkgname="collada-dom"
pkgver=2.4.0
pkgrel=1
pkgdesc="An API that provides a C++ object representation of a COLLADA XML instance document."
url="http://collada-dom.sourceforge.net/"
license=("MIT")
arch=("i686" "x86_64")
depends=("libxml2" "boost" "pcre")
# makedepends=()
source=("http://downloads.sourceforge.net/${pkgname}/collada-dom-${pkgver}.tgz")
md5sums=("20399de4206eab850c32e65c04e907cb")

build() {
	cd ${pkgname}-${pkgver}/dom
	sed -i.bak "s/domMinorVersion := 2/domMinorVersion := 4/g" Makefile
	cd external-libs
	rm -Rf minizip
	mv minizip-1.1 minizip
	ln -s . minizip/src
	ln -s . minizip/include
	cd ..
	make project=minizip
	rm build/linux-1.4/libminizip.so*
	make project=dom libOpts="-lpcre -lpcrecpp -Lbuild/linux-1.4 -lxml2 -lminizip -Wl,-soname -Wl,libcollada14dom.so.2.4"  ccFlags="-DDOM_INCLUDE_LIBXML -DCOLLADA_DOM_SUPPORT141 -fPIC -DDOM_INCLUDE_LIBXML -O3"
}

package() {
	cd ${pkgname}-${pkgver}/dom

	install -d ${pkgdir}/usr/lib ${pkgdir}/usr/include
	make prefix=${pkgdir}/usr project=dom install
	mv ${pkgdir}/usr/include/colladadom ${pkgdir}/usr/include/collada-dom

	install -D -m644 license.txt "${pkgdir}/usr/share/licenses/${pkgname}/LICENSE"
}

# vim: set noet ff=unix:

=== data/linux/arch/mitsuba/PKGBUILD ===
# Contributer: N30N <archlinux@alunamation.com>
# Contributer: Alex Combas <blenderwell@gmail.com>
# Contributer: Wenzel Jakob <wenzel@mitsuba-renderer.org>
pkgname="mitsuba-hg"
pkgver=1672
pkgrel=1
pkgdesc="Mitsuba physically based renderer"
url="http://mitsuba-renderer.org/"
license=("GPL3")
arch=("i686" "x86_64")
depends=("xerces-c" "glew" "openexr" "boost" "libpng" "libjpeg" "qt4" "collada-dom" "fftw")
makedepends=("mercurial" "scons")
provides=("mitsuba")

_hgroot="https://mitsuba-renderer.org/repos"
_hgrepo="mitsuba"

build() {
	cd ${_hgrepo}
	cp build/config-linux-gcc.py config.py

	scons --jobs=$[${MAKEFLAGS/-j/} - 1]
}

package() {
	install -d \
		${pkgdir}/usr/bin \
		${pkgdir}/usr/lib \
		${pkgdir}/usr/share/mitsuba/plugins \
		${pkgdir}/usr/share/mitsuba/data/schema \
		${pkgdir}/usr/share/mitsuba/data/ior \
		${pkgdir}/usr/share/mitsuba/data/microfacet \
		${pkgdir}/usr/share/applications \
		${pkgdir}/usr/share/pixmaps \
		${pkgdir}/usr/include/mitsuba/{core,hw,render,bidir} \
		${pkgdir}/usr/lib/python2.7/lib-dynload \
		${pkgdir}/usr/lib/python3.3/lib-dynload

	cd ${_hgrepo}
	install -m755 dist/mitsuba dist/mtsgui dist/mtsimport dist/mtssrv dist/mtsutil ${pkgdir}/usr/bin
	install -m755 dist/libmitsuba-core.so \
		dist/libmitsuba-hw.so \
		dist/libmitsuba-render.so \
		dist/libmitsuba-bidir.so \
		${pkgdir}/usr/lib
	install -m755 dist/plugins/* ${pkgdir}/usr/share/mitsuba/plugins
	install -m644 dist/data/schema/* ${pkgdir}/usr/share/mitsuba/data/schema
	install -m644 dist/data/ior/* ${pkgdir}/usr/share/mitsuba/data/ior
	install -m644 dist/data/microfacet/* ${pkgdir}/usr/share/mitsuba/data/microfacet
	install -m644 dist/python/2.7/mitsuba.so ${pkgdir}/usr/lib/python2.7/lib-dynload
	install -m644 dist/python/3.3/mitsuba.so ${pkgdir}/usr/lib/python3.3/lib-dynload
	install -m644 data/linux/mitsuba.desktop ${pkgdir}/usr/share/applications
	install -m644 src/mtsgui/resources/mitsuba48.png ${pkgdir}/usr/share/pixmaps
	install -m644 include/mitsuba/*.h ${pkgdir}/usr/include/mitsuba
	install -m644 include/mitsuba/core/* ${pkgdir}/usr/include/mitsuba/core
	install -m644 include/mitsuba/render/* ${pkgdir}/usr/include/mitsuba/render
	install -m644 include/mitsuba/hw/* ${pkgdir}/usr/include/mitsuba/hw
	install -m644 include/mitsuba/bidir/* ${pkgdir}/usr/include/mitsuba/bidir
}

# vim: set noet ff=unix:

=== data/linux/debian/control ===
Source: mitsuba
Section: graphics
Priority: optional
Maintainer: Wenzel Jakob <wenzel@cs.cornell.edu>
Build-Depends: debhelper (>= 7), build-essential, scons, qt4-dev-tools,
	libpng12-dev, libjpeg-dev, libilmbase-dev, libopenexr-dev, 
	libxerces-c-dev, libboost-dev, libglewmx-dev, libxxf86vm-dev,
	collada-dom-dev, libboost-system-dev, libboost-filesystem-dev,
	libboost-python-dev, libboost-thread-dev, libgl1-mesa-dev, 
	libglu1-mesa-dev, pkg-config, libeigen3-dev, libxml2-dev
Standards-Version: 3.8.3
Homepage: http://www.mitsuba-renderer.org

Package: mitsuba
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mitsuba renderer 
 Mitsuba is an extensible rendering framework written in portable C++. It implements unbiased as well as biased techniques and contains heavy optimizations targeted towards current CPU architectures. 
 .
 The program currently runs on Linux, MacOS X and Microsoft Windows and makes use of SSE2 optimizations on x86 and x86_64 platforms. So far, its main use has been as a testbed for algorithm development in computer graphics, but there are many other interesting applications.
 .
 Mitsuba comes with a command-line interface as well as a graphical frontend to interactively explore scenes. While navigating, a rough preview is shown that becomes increasingly accurate as soon as all movements are stopped. Once a viewpoint has been chosen, a wide range of rendering techniques can be used to generate images, and their parameters can be tuned from within the program. 

Package: mitsuba-dev
Architecture: any
Depends: qt4-dev-tools, libpng12-dev, libjpeg-dev, libilmbase-dev, 
	libopenexr-dev, libxerces-c-dev, libboost-dev, libglewmx-dev, 
	libxxf86vm-dev, collada-dom-dev, libboost-system-dev, 
	libboost-filesystem-dev, libboost-python-dev, libboost-thread-dev,
	libeigen3-dev, mitsuba
Description: Mitsuba renderer -- development files
 Mitsuba is an extensible rendering framework written in portable C++. It implements unbiased as well as biased techniques and contains heavy optimizations targeted towards current CPU architectures. 
 .
 The program currently runs on Linux, MacOS X and Microsoft Windows and makes use of SSE2 optimizations on x86 and x86_64 platforms. So far, its main use has been as a testbed for algorithm development in computer graphics, but there are many other interesting applications.
 .
 Mitsuba comes with a command-line interface as well as a graphical frontend to interactively explore scenes. While navigating, a rough preview is shown that becomes increasingly accurate as soon as all movements are stopped. Once a viewpoint has been chosen, a wide range of rendering techniques can be used to generate images, and their parameters can be tuned from within the program.

=== data/linux/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

clean:
	dh_testdir
	dh_testroot
	cp build/config-linux-gcc.py config.py
	scons -c
	rm -f build-stamp configure-stamp
	rm -Rf .sconsign.dblite .sconf_temp/
	rm -f config.py config.log
	dh_clean

configure: 

binary-arch:
	dh_testdir
	dh_testroot
	cp build/config-linux-gcc.py config.py
	scons -j 2
	dh_installdirs
	dh_auto_install
	dh_install
	for pyver in `ls dist/python`; \
	do \
		mkdir -p debian/mitsuba/usr/lib/python$$pyver/dist-packages; \
		cp -a dist/python/$$pyver/mitsuba.so debian/mitsuba/usr/lib/python$$pyver/dist-packages; \
	done
	dh_installmenu
	dh_compress
	dh_fixperms
	dh_strip
	dh_makeshlibs
	dh_shlibdeps
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep:

binary: binary-arch binary-indep

build: binary
